.\"	$NetBSD: vnd.4,v 1.16 2009/03/26 17:33:41 joerg Exp $
.\"
.\" Copyright (c) 1996, 1997 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Jason R. Thorpe.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd December 18, 2009
.Dt VND 4
.Os
.Sh NAME
.Nm vnd
.Nd vnode disk driver
.Sh SYNOPSIS
.Cd "pseudo-device vnd"
.Cd "options VND_COMPRESSION"
.Sh DESCRIPTION
The
.Nm
driver provides a disk-like interface to a file.
This is useful for a variety of applications, including swap files
and building miniroot or floppy disk images.
.Pp
This document assumes that you're familiar with how to generate kernels,
how to properly configure disks and pseudo-devices in a kernel
configuration file.
.Pp
In order to compile in support for the vnd, you must add a line similar
to the following to your kernel configuration file:
.Bd -unfilled -offset indent
pseudo-device	vnd		# vnode disk driver
.Ed
.Pp
To also compile in support for reading compressed disk images,
add the following option to your kernel config file:
.Bd -unfilled -offset indent
options        VND_COMPRESSION    # compressed vnd(4)
.Ed
.Pp
Compressed disk images are expected in the cloop2 format,
they can be created from "normal" disk images by the
.Xr vndcompress 1
program.
.Pp
There is a run-time utility that is used for configuring
both compressed and uncompressed
.Nm vnd Ns s .
See
.Xr vnconfig 8
for more information.
.Sh FILES
.Bl -tag -width /dev/XXrXvndX -compact
.It Pa /dev/{,r}vnd*
vnd device special files.
.El
.Sh SEE ALSO
.Xr config 1 ,
.Xr vndcompress 1 ,
.Xr MAKEDEV 8 ,
.Xr fsck 8 ,
.Xr mount 8 ,
.Xr newfs 8 ,
.Xr vnconfig 8
.Sh HISTORY
The vnode disk driver was originally written at the University of
Utah.
The compression handling is based on code by
.An Cliff Wright
.Aq cliff@snipe444.org .
.Sh BUGS
The
.Nm
driver does not work if the file does not reside in a local filesystem.
.Pp
The
.Nm
driver does not work if the file is sparse.
